import processing.core.*;
import java.util.ArrayList;

public class SnowAnim extends PApplet{ 
    ArrayList<SnowFlake> fallingSnow;
    ArrayList<SnowFlake> snowOnGrnd;
    ArrayList<SnowFlake> snow2Del;
    int maxFallingSnowFlakes;
    PVector wind;
    
    
    public void settings() {
        //size(100, 300);
        
        fullScreen();
    }
    
    public void setup() {
        
        fallingSnow = new ArrayList<SnowFlake>();
        
        maxFallingSnowFlakes = width;
        /*
        fallingSnow.add(new SnowFlake(new PVector(width/2,0)));
        fallingSnow.add(new SnowFlake(new PVector(width/2,0)));
        fallingSnow.add(new SnowFlake(new PVector(width/2,0)));
        fallingSnow.add(new SnowFlake(new PVector(width/2,0)));
        fallingSnow.add(new SnowFlake(new PVector(width/2,0)));
        fallingSnow.add(new SnowFlake(new PVector(width/2,0)));
        */
        
        for (int i=0;i<maxFallingSnowFlakes;i++) {
            fallingSnow.add(new SnowFlake(new PVector(random(0,width),random(0,height))));
        }
        
        
        snowOnGrnd = new ArrayList<SnowFlake>();
     
        wind = new PVector(0,0);
    }
    
    public void draw() {
        //reset background
        background(50);
    
        snow2Del = new ArrayList<SnowFlake>();
        boolean touchingSnowOnGrnd = false;
        PVector newPos = new PVector(0,0);
        
        //die Schneeflocke beim nchsten Schritt aus dem Bildschirm wre, ODER
        for (SnowFlake curSnowFlake:fallingSnow) {
          newPos = curSnowFlake.pos.add(curSnowFlake.v);
          //    die liegen Schneeflocken berhren wrde
          for (SnowFlake curSnowFlakeOnGrnd:snowOnGrnd) {
              if (curSnowFlakeOnGrnd.touchingRect(curSnowFlake)) {
                touchingSnowOnGrnd = true;
                curSnowFlake.isFalling = false;
                curSnowFlake.setRect(curSnowFlakeOnGrnd.pos.y-curSnowFlakeOnGrnd.d/2-curSnowFlake.d/2);
                snow2Del.add(curSnowFlake);
                snowOnGrnd.add(curSnowFlake);
                break;
              }
          }
          
        }
        //entferne schon mal alle bisherigen Schneeflocken.
        fallingSnow.removeAll(snow2Del);
        
        //Alle anhalten, die aus dem Fenster fallen wrden
        for (SnowFlake curSnowFlake:fallingSnow) {
          newPos = curSnowFlake.pos.add(curSnowFlake.v);
          if (newPos.y>height) {
            curSnowFlake.isFalling = false;
            curSnowFlake.setRect(height-curSnowFlake.d/2);
            snow2Del.add(curSnowFlake);
            snowOnGrnd.add(curSnowFlake);
          }
        }
        
        fallingSnow.removeAll(snow2Del);
        
        
        
        for (int i=fallingSnow.size(); i<maxFallingSnowFlakes;i++) {
            fallingSnow.add(new SnowFlake(new PVector(random(0,width),0))); 
        }
        
        for (SnowFlake curSnowFlake:fallingSnow) {
            curSnowFlake.move();
            curSnowFlake.show();
        }
        
        for (SnowFlake curSnowFlake:snowOnGrnd) {
            curSnowFlake.show();
        }
        
    }
    
    
    
  class SnowFlake {
      PVector pos; //Center of flake
      PVector v; //velocity of the flake
      float d = 10;
      float maxV = 10;
      float minV = 5;
      boolean isFalling = true;
      float vmax = random(0,5.0f);
      float rect_x,rect_y,rect_w,rect_h;
      
      public SnowFlake() {
          pos = new PVector(random(0,width),-1);
          v = new PVector(0,vmax);
          d = random(minV,maxV);
      }
      
      public SnowFlake(PVector newPos) {
          pos = newPos;
          v = new PVector(0,vmax);
          d = random(minV,maxV);
      }
      
      void setRect() {
          rect_x=pos.x;
          rect_y=pos.y;
          rect_w=2*d;
          rect_h=d/2;
      }
      
      void setRect(float newY) {
          rect_x=pos.x-d;
          rect_y=newY;
          rect_w=2*d;
          rect_h=d;
      }
      
      boolean insideRect(float x, float y) {
        return (x>rect_x && x<rect_x+rect_w && y>rect_y && y<rect_y+rect_h);  
      }
      
      boolean insideRect2(float x, float y) {
        return (x>rect_x && x<rect_x+rect_w && y>pos.y);  
      }

      boolean touchingRect(SnowFlake s) {
          return (s.pos.x>rect_x && s.pos.x<rect_x+rect_w && s.pos.y+s.d/2>pos.y-d/2);
      }
      
      void show() {
          stroke(255);
          fill(255);
          if (isFalling) {
            ellipse(pos.x,pos.y,d,d);
          } else {
            rect(rect_x,rect_y,rect_w,rect_h);
          }
          //fill(0);
          //ellipse(pos.x,pos.y,2,2);

      }
      
      void move() {
          pos.add(v);
          //pos.add(v.add(new PVector(random(-0.01,0.01),0)));
      }
      
      void move(PVector wind) {
          pos.add(v.add(new PVector(random(-0.1f,0.1f),0)));
          pos.add(wind);
      }    
  }

}